/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package actualTopic;

import candidateTopic.CandidateTopic;
import candidateTopic.CandidateTopicSet;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import matchingresult.MatchingResult;
import uk.ac.shef.wit.simmetrics.similaritymetrics.AbstractStringMetric;
import uk.ac.shef.wit.simmetrics.similaritymetrics.Levenshtein;
import constants.Constants;
import java.util.HashSet;

/**
 *
 * @author iti
 */
public class ActualTopicSet {
    List<ActualTopic> actualTopics;

    public ActualTopicSet() {
        actualTopics=new ArrayList<ActualTopic>();
    }
    
    public void loadFromFile(String filename){
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(
                    new InputStreamReader(new FileInputStream(filename), "UTF8"));
            String line = null;
            while ((line = reader.readLine()) != null) {
                ActualTopic tmp_topic=new ActualTopic();
                tmp_topic.loadFromString(line);
                actualTopics.add(tmp_topic);
            }
            reader.close();
        } catch (IOException e) {
            e.printStackTrace();
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            }
        }        
    }

    public void print(){
        for(int i=0;i<actualTopics.size();i++){
            ActualTopic tmp_topic=actualTopics.get(i);
            tmp_topic.print();
        }
    }
    
    public MatchingResult match(CandidateTopicSet candidateSet){
        AbstractStringMetric metric = new Levenshtein();//QGramsDistance();//JaroWinkler();//Levenshtein();
        int n_correct_topics=0;
        int n_candidate_topics=candidateSet.candidateTopics.size();
        int n_actual_topics=actualTopics.size();
        int i,j,k,l,m;
        boolean[] matches=new boolean[actualTopics.size()];
        for(i=0;i<matches.length;i++) matches[i]=false;        
        Set<CandidateTopic> matchedCandTopics=new HashSet<CandidateTopic>();
        Set<ActualTopic> matchedActTopics=new HashSet<ActualTopic>();
        MatchingResult tmp_res=new MatchingResult();
        for(i=0;i<n_candidate_topics;i++){
            CandidateTopic current_candidate_topic=candidateSet.candidateTopics.get(i);
            for(j=0;j<n_actual_topics;j++){
                if(!matches[j]){
                    ActualTopic current_actual_topic=actualTopics.get(j);
                    boolean match=current_actual_topic.match(current_candidate_topic);
                    if(match) {
                        matches[j]=true;
                        matchedCandTopics.add(current_candidate_topic);
                        matchedActTopics.add(current_actual_topic);

                        tmp_res.n_actual_topic_terms=tmp_res.n_actual_topic_terms+current_actual_topic.mandatoryWords.size()+current_actual_topic.optionalWords.size();
                        tmp_res.n_candidate_topic_terms=tmp_res.n_candidate_topic_terms+current_candidate_topic.terms.size();
                        tmp_res.n_topic_matches=tmp_res.n_topic_matches+1;
                        
                        Set<Set<String>> included=new HashSet<Set<String>>();
                        
                        int n_term_matches=0;
                        for(String current_candidate_term:current_candidate_topic.terms){
                            boolean term_matched=false;
                            for(Set<String> tmp_actual_set:current_actual_topic.mandatoryWords){
                                if((!included.contains(tmp_actual_set))&&(!term_matched))
                                    for(String tmp_actual_word:tmp_actual_set){
                                        float result = metric.getSimilarity(current_candidate_term, tmp_actual_word);
                                        if (result >= Constants.LEVENSHTEIN_DISTANCE_THRESHOLD){
                                            included.add(tmp_actual_set);
                                            term_matched=true;
                                            tmp_res.n_terms_matches=tmp_res.n_terms_matches+1;
                                        }
                                }
                            }
                            if(!term_matched)
                                for(Set<String> tmp_actual_set:current_actual_topic.optionalWords){
                                    if((!included.contains(tmp_actual_set))&&(!term_matched))
                                        for(String tmp_actual_word:tmp_actual_set){
                                            float result = metric.getSimilarity(current_candidate_term, tmp_actual_word);
                                            if (result >= Constants.LEVENSHTEIN_DISTANCE_THRESHOLD){
                                                included.add(tmp_actual_set);
                                                term_matched=true;
                                                tmp_res.n_terms_matches=tmp_res.n_terms_matches+1;
                                            }
                                        }
                                }
//                            if(term_matched) n_term_matches++;
                        }
                        
                        
                        
                    }
                }
            }
        }

        
        tmp_res.n_ground_truth_topics=n_actual_topics;
        
        tmp_res.term_precision=((float) tmp_res.n_terms_matches)/((float) tmp_res.n_candidate_topic_terms);
        tmp_res.term_recall=((float) tmp_res.n_terms_matches)/((float) tmp_res.n_actual_topic_terms);
        tmp_res.topic_recall=((float) tmp_res.n_topic_matches)/((float) n_actual_topics);        
        return tmp_res;

    }
    
    
    
    
}
