/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package topicevaluator;

import actualTopic.ActualTopicSet;
import candidateTopic.CandidateTopicSet;
import constants.Constants;
import java.io.*;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import matchingresult.MatchingResult;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.filefilter.DirectoryFileFilter;
import org.apache.commons.io.filefilter.RegexFileFilter;

/**
 *
 * @author gpetkos
 */
public class TopicEvaluator {

        public static Map<String,String> slotToFile;
        
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String folderNameGT=null;
        String folderNameRES=null;
        int n_args=args.length;
        Integer start_n=null;
        Integer end_n=null;
        Integer step_n=null;
        
        if(n_args!=5) {
            System.out.println("Correct use is:");
            System.out.println("java -jar TopicEvaluator.jar GroundTruthsDirectory ResultsDirectory StartN EndN StepN");
            System.out.println("StartN is the first @N value for which precision / recall will be evaluated");
            System.out.println("EndN is the last @N value for which precision / recall will be evaluated");
            System.out.println("and StepN is the step to increase th @N value");
            
            System.exit(0);
        }
        
        folderNameGT=args[0];
        folderNameRES=args[1];
        start_n=Integer.parseInt(args[2]);
        end_n=Integer.parseInt(args[3]);
        step_n=Integer.parseInt(args[4]);
        
        System.out.println("Using ground truth files in directory: "+folderNameGT);
        System.out.println("Using result files in directory: "+folderNameRES);

        File folderGT=new File(folderNameGT);
        File[] filesGT=folderGT.listFiles();

        File folderRES=new File(folderNameRES);
        File[] filesRES=folderRES.listFiles();
        
        int n_timeslots=filesGT.length;
        File[][] pairsToMatch=new File[n_timeslots][2];
        for(int i=0;i<n_timeslots;i++){
            String nameToMatch=filesGT[i].getName();
            boolean matched=false;
            int pos=0;
            while((!matched)&&(pos<filesRES.length)){
                if(filesRES[pos].getName().equals(nameToMatch)){
                    matched=true;
                }
                else
                    pos=pos+1;
            }
            if(matched){
                pairsToMatch[i][0]=filesGT[i];
                pairsToMatch[i][1]=filesRES[pos];
            }
            else{
                System.out.println("Could not match ground truth file nameToMatch to any result file");
                System.out.println("Please make sure that results for all target timeslots are included in the results directory");
                System.out.println("Exiting");
                System.exit(0);
            }
            
        }

/*        System.out.println("Comparison pairs");
        for(int i=0;i<n_timeslots;i++){
            System.out.println(pairsToMatch[i][0].getAbsolutePath()+" --- "+pairsToMatch[i][1].getAbsolutePath());
        }
  */      
        for(int i=start_n;i<=end_n;i=i+step_n){
            MatchingResult overallResult=new MatchingResult();

            for(int j=0;j<n_timeslots;j++){
                String ground_truth_filename=pairsToMatch[j][0].getAbsolutePath();
                String candidate_results_filename=pairsToMatch[j][1].getAbsolutePath();
                ActualTopicSet actualTopics=new ActualTopicSet();
                actualTopics.loadFromFile(ground_truth_filename);
                CandidateTopicSet candidateTopics=new CandidateTopicSet();
                candidateTopics.loadFromFile(candidate_results_filename,i);
                MatchingResult matchingResult_tmp=actualTopics.match(candidateTopics);
                overallResult.add(matchingResult_tmp);
            }
            
            
            System.out.println("Results @"+i+": (topic recall / term precision / term recall)");
            overallResult.print();
        }
        
    }
    
}
